//O[oϐ
float4x4 g_mWorldViewProjection; //Wϊs
float4x4 g_mWorld;
float4x4 g_mView;
float4x4 g_mProj;
texture  g_Texture;              //eNX`

//fBt[Y
float4 g_Diffuse = {1.0f,1.0f,1.0f,1.0f};

//ArGgl
float4 g_Ambient = {0.7f,0.7f,1.0f,1.0f};
//vO`悵̂ɍ킹ĎRɓnF
float4 g_FreeColor = {1.0f,1.0f,1.0f,1.0f};

//{F
float4 g_BaseColor = {1.0f, 1.0f, 1.0f, 1.0f};

float3 g_DLightPos		: Position	={0.0f,-10.0f,0.0f};
float4 g_DLightColor	: COLOR0	={0.8f,0.8f,0.8f,0.8f};

float3 Lamp0Color  : Specular={1.0f,0.0f,0.0f};
float4 LightPosition = float4(30.0,10.0,0.0,0.0);

bool texture_flg=false;	//eNX`̗L@Ȃ΃}eA̒lg



//_VF[_̓
struct VS_INPUT
{
	float4 Pos		: POSITION;			//_W
	float4 Normal	: NORMAL;			//@xNg
	float2 UV		: TEXCOORD0;		//eNX`UV
	float4 Diffuse		: COLOR0;			//ft[YF
	float4 Specular		: COLOR1;			//XyLF
};

//	_VF[_̏o
struct VS_OUTPUT
{
	float4 Pos : POSITION;		
	float4 Diffuse : COLOR0;	
	float4 Specular	: COLOR1;	//XyLF
	float2 UV : TEXCOORD0;	//	UVW
	float2 Normal : TEXCOORD1;		//	@

};

//sNZVF[_
struct PS_INPUT
{
	float4 Diffuse		: COLOR0;			//ft[YF
	float4 Specular		: COLOR1;			//XyLF
	float2 UV			: TEXCOORD0;		//eNX`UV
	float2 Normal		: TEXCOORD1;		//@

};

//sNZVF[_o
struct PS_OUTPUT
{
	float4 RGB : COLOR0;
};


struct appdata
{
	float3 Pos : POSITION;		
	float4 UV : TEXCOORD0;	
	float4 Normal: NORMAL;
	float4 Tangent:TANGENT0;
	float4 Binormal:BINORMAL0;
	float4 Color	: COLOR;	//XyLF
	float4 Blend:BLEND;
	int4 Indices:BLENDINDICES;
};


//eNX`̃TvO@
sampler MeshTextureSampler =
	sampler_state
{
	Texture = < g_Texture >;//Ώۂ̃eNX`(O󂯎܂)
	MinFilter = LINEAR; //k̃TvO(LINEAR`⊮)
	MagFilter = LINEAR; //g厞
	MipFilter = LINEAR;   //~bv}bv

	//eNX`AhbVO[h
	AddressU = Clamp;	//iClanp0`1ȊO̍W̎ɒ[̃sNZЂ̂΂j
	AddressV = Clamp;
};

//----------------------------------
//_VF[_i@[hԂɕϊsNZVF[_ɓnj
//----------------------------------
VS_OUTPUT RenderSceneVS(const VS_INPUT _input)
{
	VS_OUTPUT _output;

	float4x4 mwvp;
	mwvp = mul( g_mWorld, g_mView );	
	mwvp = mul( mwvp, g_mProj );

	_output.Pos			=	 mul(_input.Pos, mwvp);	//W
	_output.Diffuse		=	_input.Diffuse;		//fBt[Y
	_output.Specular	=	_input.Specular;	//XyL[
	_output.UV			=	_input.UV;			//UV

	//[hs񂩂ړs𔲂̂Ŗ@
	float4x4 normal=g_mWorld;
	normal._41=0;
	normal._42=0;
	normal._43=0;
	_output.Normal		=	mul(_input.Normal,normal);	//@

	_output.Normal		=normalize(_output.Normal);

	return _output;
}


//----------------------------------
//sNZVF[_
//----------------------------------
PS_OUTPUT RenderScenePS( const PS_INPUT _input )
{
	PS_OUTPUT _output=(PS_OUTPUT)0;

	float4 col;


//	 float Power=dot(normalize(IN.UV2),-normalize(g_DirectionalLightPos)); 

	if(texture_flg==true)
	{
		col = (_input.Diffuse + g_Ambient);
		_output.RGB = col*tex2D( MeshTextureSampler, _input.UV );
	}
	else
	{
		col = g_Diffuse;	 
		_output.RGB = col;		
	}

	return _output;
}

PS_OUTPUT JellyScenePS( const PS_INPUT _input )
{
	PS_OUTPUT _output=(PS_OUTPUT)0;

	float4 col;

	if(texture_flg==true)
	{
		col = ((g_FreeColor*1.2));
		_output.RGB = col*tex2D( MeshTextureSampler, _input.UV );
	}
	else
	{
		col = g_Diffuse;	 
		_output.RGB = col;
	}
	return _output;
}

//TS`
float4 Coral_PS( const PS_INPUT _input ):COLOR0
{

	//Cg
	float Power=dot(normalize(_input.Normal),-normalize(g_DLightPos)); //Cg̔˂̋

	Power=clamp(Power,0.5f,1.0f);//Ae̋

	//F
	float4 RC = tex2D( MeshTextureSampler, _input.UV );	//ːF
	float4 SurfaceColor = RC * g_DLightColor;

	SurfaceColor.rgb = SurfaceColor.rgb * Power;

//	SurfaceColor.a=SurfaceColor.a;

	return SurfaceColor;

}

//O̐F̂܂
PS_OUTPUT FreeColor_PS( const PS_INPUT _input )
{
	PS_OUTPUT _output=(PS_OUTPUT)0;

	float4 col;

	if(texture_flg==true)
	{
		col = ((g_FreeColor*1.2));	//F
		_output.RGB = col*tex2D( MeshTextureSampler, _input.UV );
	}
	else
	{
		col = (g_FreeColor*1.4);
		_output.RGB = col;		
	}
	return _output;
}

//O̐F{ƂƂ̐F
PS_OUTPUT BlendColor_PS( const PS_INPUT _input )
{
	PS_OUTPUT _output=(PS_OUTPUT)0;

	float4 col;

	if(texture_flg==true)
	{
		//Cg
		float Power=dot(normalize(_input.Normal),-normalize(g_DLightPos)); //Cg̔˂̋

		Power=clamp(Power,0.5f,1.0f);

		//F
		float4 RC = tex2D( MeshTextureSampler, _input.UV );	//ːF
		float4 SurfaceColor = RC * g_DLightColor;

		SurfaceColor.rgb = SurfaceColor.rgb * Power;//rgbɌ̋|

		_output.RGB=SurfaceColor;
	}
	else
	{
		col = ((g_Diffuse+g_FreeColor)/2);	//
		_output.RGB =col;
	}
	return _output;
}

//
PS_OUTPUT Flower_PS( const PS_INPUT _input )
{
	PS_OUTPUT _output=(PS_OUTPUT)0;


		//Cg
		float Power=dot(normalize(_input.Normal),-normalize(g_DLightPos)); //Cg̔˂̋

		Power=clamp(Power,0.5f,1.0f);

		float4 RC;

		//̔ɋ߂͂蔒@̂ق͔
		bool dead=false;				//Ԃ̐
		if(g_FreeColor.a>=1.0f)dead=true;//Ԃ̕sx1.0ȏȂ玀ł

		if(g_Diffuse.r>=0.7)
		{
			//Ԃ͂Ă畣͂@ႦY
			if(dead==true){
				RC = ((g_FreeColor));	//}eÂ̂̐F苭
			}
			else{
				RC = ((g_Diffuse*1.5+g_FreeColor));	//}eÂ̂̐F苭
			}
		}
		else
		{
			RC = ((g_Diffuse+g_FreeColor));	//
			RC.a=g_FreeColor.a*5;
		}
	

		float4 SurfaceColor = RC * g_DLightColor;

		SurfaceColor.rgb = SurfaceColor.rgb * Power;//rgbɌ̋|
	

		_output.RGB =SurfaceColor;

		return _output;
}

//
PS_OUTPUT MiniFlower_PS( const PS_INPUT _input )
{
	PS_OUTPUT _output=(PS_OUTPUT)0;


		//Cg
		float Power=dot(normalize(_input.Normal),-normalize(g_DLightPos)); //Cg̔˂̋

		Power=clamp(Power,0.5f,1.0f);

		float4 RC;

		bool dead=false;				//Ԃ̐
		if(g_FreeColor.a>=1.0f)dead=true;//Ԃ̕sx1.0ȏȂ玀ł

		//̔ɋ߂Ƃ̓ŕ`@ς@r̒l荂Δ̕
		if(g_Diffuse.r>=0.7)
		{
			RC = ((g_Diffuse*1.5*g_FreeColor));	//}eÂ̂̐F苭 ʂgfreecolorOɋ߂ÂĂ
		}
		else
		{
			RC = ((g_Diffuse+g_FreeColor));	//
			RC.a=0.5f;
		}
	

		float4 SurfaceColor = RC * g_DLightColor;

		SurfaceColor.rgb = SurfaceColor.rgb * Power;//rgbɌ̋|
	

		_output.RGB =SurfaceColor;

		return _output;
}


//
PS_OUTPUT Ivy_PS( const PS_INPUT _input )
{
	PS_OUTPUT _output=(PS_OUTPUT)0;

	float4 col;

	if(texture_flg==true)
	{
		//Cg
		float Power=dot(normalize(_input.Normal),-normalize(g_DLightPos)); //Cg̔˂̋

		Power=clamp(Power,0.5f,1.0f);

		//F
		float4 RC = tex2D( MeshTextureSampler, _input.UV );	//ːF
		float4 SurfaceColor = RC * g_DLightColor;

		SurfaceColor.rgb = SurfaceColor.rgb * Power;//rgbɌ̋|

		_output.RGB=SurfaceColor;
	}
	else
	{
		col = ((g_Diffuse+g_FreeColor/2)/2);	//
		_output.RGB =col;
	}
	return _output;
}

//C\M`N
PS_OUTPUT Anemone_PS( const PS_INPUT _input )
{
	PS_OUTPUT _output=(PS_OUTPUT)0;

	float4 col;

	if(texture_flg==true)
	{
		//Cg
		float Power=dot(normalize(_input.Normal),-normalize(g_DLightPos)); //Cg̔˂̋

		Power=clamp(Power,0.5f,0.8f);

		//F
		float4 RC = tex2D( MeshTextureSampler, _input.UV );	//ːF

		float4 SurfaceColor = RC * g_DLightColor;
		SurfaceColor.rgb = SurfaceColor.rgb * Power;//rgbɌ̋|

		_output.RGB=SurfaceColor;
	}
	return _output;
}


//Xc
/*float4 MoritaPS( VS_OUTPUT IN  ):COLOR
{
float4 result=float4(Lamp0Color,1);

float Power=dot(normalize(IN.UV2),-normalize(g_DirectionalLightPos)); 

Power=clamp(Power,0.0f,1.0f);

return result*Power;
}
*/

//eNjbNƃpX
//̃eNjbNpX`ăVF[_vO؂ւ邱Ƃł܂B
technique RenderScene
{
	//{
	pass P0
	{
		VertexShader = compile vs_2_0 RenderSceneVS();
		PixelShader = compile ps_2_a RenderScenePS();
	}
	//NQ
	pass P1_Jelly
	{
		VertexShader = compile vs_2_0 RenderSceneVS();
		PixelShader = compile ps_2_a JellyScenePS();
	}
	//TS
	pass P2_Coral
	{
		VertexShader = compile vs_2_0 RenderSceneVS();
		PixelShader = compile ps_2_a Coral_PS();
	}
	//RȐF
	pass P3_Free
	{
		VertexShader = compile vs_2_0 RenderSceneVS();
		PixelShader = compile ps_2_a FreeColor_PS();
	}

	//O̐F{ƂƂ̐F
	pass P4_Blend
	{
		VertexShader = compile vs_2_0 RenderSceneVS();
		PixelShader = compile ps_2_a BlendColor_PS();
	}
	//
	pass P5_Blend
	{
		VertexShader = compile vs_2_0 RenderSceneVS();
		PixelShader = compile ps_2_a Ivy_PS();
	}
	//
	pass P6_Anemoe
	{
		VertexShader = compile vs_2_0 RenderSceneVS();
		PixelShader = compile ps_2_a Anemone_PS();
	}
	pass P7_Flower
	{
		VertexShader = compile vs_2_0 RenderSceneVS();
		PixelShader = compile ps_2_a Flower_PS();
	}
	pass P8_MiniFlower
	{
		VertexShader = compile vs_2_0 RenderSceneVS();
		PixelShader = compile ps_2_a MiniFlower_PS();
	}
}

